#include "glwin.h"
#include "stdio.h"
#include "stdlib.h"
#include "assert.h"
#include "math.h"

/* this has been hacked away during a nice evening... */
#define MAXPT 2048
#define UNDEF 1.245e56
typedef struct {double x,y;} point;
point pt[MAXPT];
int nextfree;
char *fname;
int wx0,wy0,wx1,wy1;
double ux0=0,uy0=0,ux1=1,uy1=1;
int lastx=0,lasty=0;
char *pixelbuf;
GLint ww,wh,i;
char *dfname;
char *ffname;
FILE *pipe;
int gnuplot=1;
int linedraw=0;
int picdraw=0;
int fit=0;
int splinedraw=0;

int ptcomp(const void *p1,const void*p2)
{
  double d=((point*)p1)->x-((point*)p2)->x;
  if (d>0) return 1;
  else if (d<0) return -1;
  else return 0;
}
void ptsort(void)
{
  qsort(pt,MAXPT,sizeof(point),ptcomp);
	  nextfree=0;
  for (i=0;i<MAXPT;i++)
    {
      if (pt[i].x==UNDEF) 
	{
	  nextfree=i;
	  break;
	}
    }
}

void ptins(void)
{
  double x,y;
  pt[nextfree].x=lastx;
  pt[nextfree].y=lasty;
  x=ux0+ (pt[nextfree].x-wx0)*(ux1-ux0)/(wx1-wx0);
  y=uy0+ (pt[nextfree].y-wy0)*(uy1-uy0)/(wy1-wy0);
  
  printf("insert: %g %g\n",x,y);
  nextfree++;
  ptsort();
}

void ptdel(void)
{
  
  double x=lastx,y=lasty;
  double d, dx,dy;
  double mindist;
  int imin;
  mindist=1.0e30;
  for (i=0;i<nextfree;i++)
    {
      dx=x-pt[i].x;
      dy=y-pt[i].y;
      d=sqrt(dx*dx+dy*dy);
      if (d<mindist) 
	{
	  mindist=d;
	  imin=i;
	}
    }
  if (mindist<3)
    {
      x=ux0+ (pt[imin].x-wx0)*(ux1-ux0)/(wx1-wx0);
      y=uy0+ (pt[imin].y-wy0)*(uy1-uy0)/(wy1-wy0);
      printf("delete: %g %g\n", x,y);

      pt[imin].x=UNDEF;
    }
  ptsort();
}


double getval(char *s)
{

  double val=0.0;
  printf("\007Enter %s: ",s);
  scanf("%le",&val);
  return val;
}



void gpopen(void)
{

  char gpcmd[128];
  sprintf(gpcmd,"gnuplot -geometry 500x500+%d+%d",ww+10,0);
  pipe=popen(gpcmd,"w");
  fprintf(pipe,"set grid\n");
}

void gpclose(void)
{
  pclose(pipe);
}

static void Reshape(glWindow w, void *info,int width, int height)
{
  glViewport(0, 0, (GLint)width, (GLint)height);
}

static GLenum MouseMove(glWindow w, void * data,int x,int y, GLenum mask)
{
  lastx=x,lasty=y;

  return GL_FALSE;
}

static GLenum MouseDown(glWindow w, void * data,int x,int y, GLenum mask)
{
  lastx=x,lasty=y;
  if (mask&GLW_LEFTBUTTON)
    {
      ptins();
      return GL_TRUE;
    }
  if (mask&GLW_RIGHTBUTTON)
    {
      ptdel();
      return GL_TRUE;
    }
  return GL_FALSE;
}

static GLenum MouseUp(glWindow w, void * data,int x,int y, GLenum mask)
{
  return GL_FALSE;
}

static GLenum Key(glWindow w, void * info,int key, GLenum mask)
{
  switch(key)
    {
    case GLW_Escape:
    case GLW_q:
      glwQuit(w);
      break;
    case GLW_h:
    case GLW_question:
      printf("\n\
gldigi fname.ppm [output.dat]\n\
\n\
is used to digitalize measured curves on ppm images (e.g. from scans).\n\
The input file has to be  an ppm image, the output file contains a list of pairs\n\
of x y values ready for gnuplot. If no output file name is given, output goes\n\
to fname.dat.\n\
\n\
Currently, the following commands are recognized:\n\
x,X           : Enter x0 resp. x1 gauging points for x axis \n\
y,Y           : Enter y0 resp. y1 gauging points for y axis \n\
i,mouse-left  : insert point under mouse cursor into point list\n\
d,mouse-right : delete inserted point under mouse cursor\n\
g             : toggle gnuplot\n\
");
      /* 
	 l toggle linear interp. in image
	 s toggle spline interp. in image 
	 f toggle fit in image
       */

      break;
    case GLW_i:
      ptins();
      break;
    case GLW_D:
      for(i=0;i<MAXPT;i++) pt[i].x=pt[i].y=pt[i].x=pt[i].y=UNDEF;
      nextfree=0;
      break;
    case GLW_d:
      ptdel();
      break;
    case GLW_l:
      linedraw=!linedraw;
      break;
    case GLW_p:
      picdraw=!picdraw;
      break;
    case GLW_s:
      splinedraw=!splinedraw;
      break;
    case GLW_g:
      gnuplot=!gnuplot;
      if (gnuplot) gpopen(); else gpclose();
      break;
    case GLW_f:
      fit=!fit;
      break;
    case GLW_x:
      wx0=lastx;
      ux0=getval("x0");
      printf("x0:  %d -> %g\n",wx0,ux0);
      break;
    case GLW_y:
      wy0=lasty;
      uy0=getval("y0");
      printf("y0:  %d -> %g\n",wy0,uy0);
      break;
    case GLW_X:
      wx1=lastx;
      ux1=getval("x1");
      printf("x1:  %d -> %g\n",wx1,ux1);
      break;
    case GLW_Y:
      wy1=lasty;
      uy1=getval("y1");
      printf("y1:  %d -> %g\n",wy1,uy1);
      break;
    default:;
    }

  return GL_TRUE;

}


void draw(glWindow w, void *data)
{
  int i;
  double dx,dy;
  glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

  if (picdraw)
    {
      glPixelTransferf(GL_RED_BIAS,0.67);
      glPixelTransferf(GL_RED_SCALE,0.33);

      glPixelTransferf(GL_GREEN_BIAS,0.67);
      glPixelTransferf(GL_GREEN_SCALE,0.33);

      glPixelTransferf(GL_BLUE_BIAS,0.67);
      glPixelTransferf(GL_BLUE_SCALE,0.33);

    }
      glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
      glPixelStorei(GL_PACK_SWAP_BYTES, GL_TRUE);
      glRasterPos3i(0, 0 ,0);
      glDrawPixels(ww,wh, GL_RGB, GL_UNSIGNED_BYTE, pixelbuf);

  if (picdraw)
    {
      glPixelTransferf(GL_RED_BIAS,0.0);
      glPixelTransferf(GL_RED_SCALE,1.0);

      glPixelTransferf(GL_GREEN_BIAS,0.0);
      glPixelTransferf(GL_GREEN_SCALE,1.0);

      glPixelTransferf(GL_BLUE_BIAS,0.0);
      glPixelTransferf(GL_BLUE_SCALE,1.0);

    }


  glBegin(GL_LINES);
  glPointSize(100);
  glColor3f(0,0,1);
  dx=ww*0.005;
  dy=wh*0.005;
  for(i=0;i<nextfree;i++)
    {
      glVertex3d(pt[i].x-dx,wh-pt[i].y-dy,1);
      glVertex3d(pt[i].x+dx,wh-pt[i].y+dy,1);
      glVertex3d(pt[i].x+dx,wh-pt[i].y-dy,1);
      glVertex3d(pt[i].x-dx,wh-pt[i].y+dy,1);
    }
  glColor3f(1,0,0);
  dx=ww*0.01;
  dy=wh*0.01;
  glVertex3d(wx0,wh-wy0,1);
  glVertex3d(wx0+dx,wh-wy0,1);
  glVertex3d(wx0,wh-wy0,1);
  glVertex3d(wx0,wh-wy0+dy,1);
  
  glVertex3d(wx1-dx,wh-wy1,1);
  glVertex3d(wx1,wh-wy1,1);
  glVertex3d(wx1,wh-wy1-dy,1);
  glVertex3d(wx1,wh-wy1,1);
  
  glEnd();
  
  if (linedraw && nextfree>=2)
    {
      glColor3f(0,0,1);
      glBegin(GL_LINE_STRIP);
      for (i=0;i<nextfree;i++)
	glVertex3d(pt[i].x,wh-pt[i].y,1);
      glEnd();
    }
  if (splinedraw && nextfree>=4)
    {
      #include "stdsys/spline.h"
      double h,x;
      int n=300;
      CSpline s=csplCreateBegin();
      for (i=1;i<nextfree-1;i++)
	csplAccumulate(s,pt[i].x,pt[i].y);
      csplSetBC(s,
		(pt[0].y-pt[1].y)/(pt[0].x-pt[1].x),
		(pt[nextfree-1].y-pt[nextfree-2].y)/
		(pt[nextfree-1].x-pt[nextfree-2].x));
      csplCreateEnd(s);
      h=(pt[nextfree-1].x-pt[0].x)/((double) n);
      glColor3f(0,0,1);
      glBegin(GL_LINE_STRIP);
      for(x=pt[0].x;x<=pt[nextfree-1].x;x+=h)
	{
	  glVertex3d(x,wh-csplEval(s,x),1);
	}
      glEnd();
		
    }
  glwSwapBuffers(w);
  
  if (gnuplot && nextfree>=2)
    {
      double x,y;
      FILE *datafile=fopen(dfname,"w");
      fprintf(datafile,"\n");
      for(i=0;i<nextfree;i++)
	{
	  x=ux0+ (pt[i].x-wx0)*(ux1-ux0)/(wx1-wx0);
	  y=uy0+ (pt[i].y-wy0)*(uy1-uy0)/(wy1-wy0);
	  fprintf(datafile,"%e %e\n",x,y);
	}
      fclose(datafile);

      if (fit && nextfree>5)
	{
	  int i;
	  char cmd[128],xdfname[128];
	  for (i=0;;i++)
	    if (dfname[i]!='.') xdfname[i]=dfname[i];
	  xdfname[i]='\0';
	  sprintf(cmd,"mpfit -meas %s -func %s -fit",dfname,ffname);
	  system(cmd);
	  
	  fprintf(pipe,"plot '%s'  w p  1, '%s-%s-%s.dat' w l 1\n",dfname,xdfname,ffname,xdfname);
	}
      else
	  fprintf(pipe,"plot '%s' w linesp  1 1\n",dfname);

      fflush(pipe);
    }
}

char line[128];
void getline(FILE *f)
{
  do
    {
      fgets(line,128,f);
    }
  while (line[0]=='#');
}

int main(int argc, char *argv[])
{
  glWindow w;
  int frame=0;
  FILE *f=fopen(argv[1],"r");
  char s[128];
  dfname=argv[2];
  ffname=argv[2];
  assert(f);
  assert(dfname);
  
  glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

  getline(f);
  sscanf(line, "P6\n",s);
  getline(f);
  sscanf(line, "%d %d\n", &ww, &wh);
  getline(f);
  sscanf(line, "%d\n", &i);
  pixelbuf=calloc(3,(ww+1)*wh);
  for(i=0;i<wh;i++)
    fread(pixelbuf+ww*3*(wh-i-1), 3, ww, f);
  fclose(f);
  gpopen();

  glwInitPosition(0,0,ww+frame,wh+frame);
  w=glwCreate();
  glwSetKeyDownFunc(w,Key);
  glwSetMouseDownFunc(w,MouseDown);
  glwSetMouseUpFunc(w,MouseUp);
  glwSetMouseMoveFunc(w,MouseMove);
  glwSetReshapeFunc(w,Reshape);
  glwSetRedrawFunc(w,draw);

  glEnable(GL_DEPTH_TEST);
  glDepthFunc(GL_LESS);
  glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
  glClearColor(1.0,0.0,0.0,1.0);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glShadeModel(GL_SMOOTH);
  glEnable(GL_LIGHTING);
  glEnable(GL_COLOR_MATERIAL);
  glEnable(GL_LIGHT0);

  glViewport(0, 0, ww, wh);
  glOrtho(0, ww,0, wh,-1,1);
  
  wx0=0;
  wx1=ww;
  wy0=wh;
  wy1=0;
  for(i=0;i<MAXPT;i++) pt[i].x=pt[i].y=pt[i].x=pt[i].y=UNDEF;
  nextfree=0;

  glwProcess(w,NULL);
    
  free(pixelbuf);
  glwDestroy(w);
}






